using System;

namespace BUGSHARp1
{
    class Program
    {
        public static int suma = 0;
        static void F(int[] niz, int beginning, int end, int k)
        {
            int i, j;
            if (k > 0)
            {
                for (i = beginning; i <= end; i++)
                {
                    for (j = i; j <= end; j++)
                    {
                        F(niz, i, j, k - 1);
                    }
                }
            }
            else
            {
                for (i = beginning; i <= end; i++)
                {
                    suma += niz[i];
                }
            }
        }
        static void Main(string[] args)
        {
            int n, k, i, delilac=1;
            string input = Console.ReadLine();
            string[] vrednosti;
            vrednosti = input.Split(' ');
            n = int.Parse(vrednosti[0]);
            k = int.Parse(vrednosti[1]);
            int[] niz = new int[n+1];
            input = Console.ReadLine();
            vrednosti = input.Split(' ');
            for(i=1;i<=n;i++)
            {
                niz[i] = int.Parse(vrednosti[i - 1]);
            }
            for(i=0;i<9;i++)
            {
                delilac *= 10;
            }
            delilac += 7;
            F(niz, 1, n, k);
            Console.WriteLine(suma % delilac);
        }
    }
}